load data;
data = data';
%samples = data points
%leads = features
[nrLeads, nrSamples] = size(data);

%for plotting and fourrier transform:
Fs = 1000;                    % Sampling frequency
T = 1/Fs;                     % Sample time
L = nrSamples;                % Length of signal
t = (0:L-1)*T;                % Time vector


%%%-----Part 1 ----------------------------------
%experiment with plotting some of the leads
figure(1)
plot(t, data(1,:));
title('signal');
xlabel('time')
ylabel('X(time)')
print('ECGfig1.png', '-dpng')
%%%---------------------------------------


%%%---- Part 2-----------------------------------
%first scale the features...
for f=1:nrLeads
    %%%
    TODO
    %%%
end
%(Alternatively, you can also try and use "max(data,[],2)", instead of the loop)
%%%---------------------------------------



%%%-----Part 3----------------------------------
%make the features zero mean, put the result in X.
%%%
Xmean = TODO
X = TODO
%
%%%---------------------------------------



%%%-----Part 4----------------------------------
%create the covariance matrix, M
%%%
M = TODO
%
%%%---------------------------------------


%perform the eigenvalue decomposition
[U, lambda] = eig(M);
U = U(:, end:-1:1);
lambda = diag(lambda);
lambda = lambda(end:-1:1);
Z = U' * X;


%%%------Part 5---------------------------------
%the eigenvalues stored in lambda tell you something about the variance.
%lambda(i) is the variance in the i-th direction. So what do the 
%following vectors tell you? How many PCs do you need to
%represent at leat 95% of the total variance? 
L1 = (lambda)/sum(lambda)
L2 = cumsum(lambda)/sum(lambda)
%%%---------------------------------------





%%%------Part 6---------------------------------
figure(2);
clf;
%%% 
%TODO    
d = 12; %%<- change this to a suitable parameter!
%%% 
tit = sprintf('the first %d principal components', d);
subplot(d, 1, 1);
for i = 1:d
    subplot(d, 1, i);
    TODO    
    if i == 1
        title(tit)
    elseif i == d
        xlabel('time')
    end
    ylabel('X(time)')
end
print('ECGfig2.png', '-dpng') %<--- include this figure!
%%%---------------------------------------





%%%------Part 7---------------------------------
figure(3);
clf;
subplot(d, 1, 1);
for i = 1:d
    subplot(d, 1, i);
    TODO    

    %% fourrier transform
    NFFT = 2^nextpow2(L); % Next power of 2 from length of y
    Y = fft(pc,NFFT)/L;
    maxFreqFFT = Fs/2; %the maximum frequency we can find with FFT
    NFFToverTwoPlusOne = NFFT/2+1; %<- this is the index of Y that corresponds to maxFreqFFT
    maxFreqPlot = 20; % the max. frequency we want to show in the plot
    maxIndex = floor( (maxFreqPlot/maxFreqFFT) * NFFToverTwoPlusOne );
    f = maxFreqPlot * linspace(0,1, maxIndex);
    y =  2 * abs( Y(1:maxIndex) );
    plot(f,y);
    if i == 1
        title('Single-Sided Amplitude Spectrum of the firs principal components')
    elseif i == d
        xlabel('Frequency (Hz)')
    end
    ylabel('|Y(f)|')
end
print('ECGfig3.png', '-dpng') %<--- include this figure!
%%%---------------------------------------




